diff --git a/yum/update_md.py b/yum/update_md.py
index b1d7388..a2b2008 100644
--- a/yum/update_md.py
+++ b/yum/update_md.py
@@ -24,7 +24,7 @@ Update metadata (updateinfo.xml) parsing.
 import sys
 import gzip
 
-from textwrap import wrap
+from yum.i18n import utf8_text_wrap
 from yum.yumRepo import YumRepository
 from yum.misc import to_xml
 
@@ -95,7 +95,7 @@ class UpdateNotice(object):
             for bz in bzs:
                 buglist += " %s%s\n\t    :" % (bz['id'], bz.has_key('title')
                                                and ' - %s' % bz['title'] or '')
-            head += buglist[:-1].rstrip() + '\n'
+            head += buglist[: - 1].rstrip() + '\n'
 
         # Add our CVE references
         cves = filter(lambda r: r['type'] == 'cve', self._md['references'])
@@ -103,11 +103,11 @@ class UpdateNotice(object):
             cvelist = "       CVEs :"
             for cve in cves:
                 cvelist += " %s\n\t    :" % cve['id']
-            head += cvelist[:-1].rstrip() + '\n'
+            head += cvelist[: - 1].rstrip() + '\n'
 
         if self._md['description'] is not None:
-            desc = wrap(self._md['description'], width=64,
-                        subsequent_indent=' ' * 12 + ': ')
+            desc = utf8_text_wrap(self._md['description'], width=64,
+                                  subsequent_indent=' ' * 12 + ': ')
             head += "Description : %s\n" % '\n'.join(desc)
 
         #  Get a list of arches we care about:
@@ -119,7 +119,7 @@ class UpdateNotice(object):
                 if file['arch'] not in arches:
                     continue
                 filelist += " %s\n\t    :" % file['filename']
-        head += filelist[:-1].rstrip()
+        head += filelist[: - 1].rstrip()
 
         return head
 
@@ -236,17 +236,17 @@ class UpdateNotice(object):
 
     def xml(self):
         """Generate the xml for this update notice object"""
-        msg="""
+        msg = """
 <update from="%s" status="%s" type="%s" version="%s">
   <id>%s</id>
   <title>%s</title>
   <release>%s</release>
   <issued date="%s"/>
   <description>%s</description>\n""" % (to_xml(self._md['from']),
-                to_xml(self._md['status']), to_xml(self._md['type']), 
-                to_xml(self._md['version']),to_xml(self._md['update_id']),
+                to_xml(self._md['status']), to_xml(self._md['type']),
+                to_xml(self._md['version']), to_xml(self._md['update_id']),
                 to_xml(self._md['title']), to_xml(self._md['release']),
-                to_xml(self._md['issued'], attrib=True), 
+                to_xml(self._md['issued'], attrib=True),
                 to_xml(self._md['description']))
         
         if self._md['references']:
@@ -398,7 +398,7 @@ class UpdateMetadata(object):
         if fileobj:
             fileobj.write(end)
         else:
-            msg+= end
+            msg += end
 
         if fileobj:
             return
diff --git a/yum/yumRepo.py b/yum/yumRepo.py
index b762deb..7a83756 100644
--- a/yum/yumRepo.py
+++ b/yum/yumRepo.py
@@ -44,6 +44,8 @@ import warnings
 import glob
 import shutil
 import stat
+import errno
+import tempfile
 
 #  If you want yum to _always_ check the MD .sqlite files then set this to
 # False (this doesn't affect .xml files or .sqilte files derived from them).
@@ -207,7 +209,11 @@ class YumPackageSack(packageSack.PackageSack):
                 repo.checkMD(db_un_fn, mdtype, openchecksum=True)
             except URLGrabError:
                 if not repo.cache:
-                    os.unlink(db_un_fn)
+                    try:
+                        os.unlink(db_un_fn)
+                    except OSError, e:
+                        if e.errno != errno.ENOENT:
+                            raise # Could have an error before anything happens
             else:
                 result = db_un_fn
 
@@ -774,6 +780,9 @@ class YumRepository(Repository, config.RepoConf):
         start = package.hdrstart
         end = package.hdrend
         basepath = package.basepath
+        # yes, I know, don't ask
+        if not os.path.exists(self.hdrdir):
+            os.makedirs(self.hdrdir)
 
         return self._getFile(url=basepath, relative=remote, local=local, start=start,
                         reget=None, end=end, checkfunc=checkfunc, copy_local=1,
@@ -874,12 +883,20 @@ class YumRepository(Repository, config.RepoConf):
 
     def _getFileRepoXML(self, local, text=None, grab_can_fail=None):
         """ Call _getFile() for the repomd.xml file. """
+        def _cleanup_tmp():
+            try:
+                os.unlink(tfname)
+            except:
+                pass
         checkfunc = (self._checkRepoXML, (), {})
         if grab_can_fail is None:
             grab_can_fail = 'old_repo_XML' in self._oldRepoMDData
         try:
+            # This is named so that "yum clean metadata" picks it up
+            tfname = tempfile.mktemp(prefix='repomd', suffix="tmp.xml",
+                                     dir=os.path.dirname(local))
             result = self._getFile(relative=self.repoMDFile,
-                                   local=local,
+                                   local=tfname,
                                    copy_local=1,
                                    text=text,
                                    reget=None,
@@ -887,16 +904,27 @@ class YumRepository(Repository, config.RepoConf):
                                    cache=self.http_caching == 'all')
 
         except URLGrabError, e:
+            _cleanup_tmp()
             if grab_can_fail:
                 return None
             raise Errors.RepoError, 'Error downloading file %s: %s' % (local, e)
         except (Errors.NoMoreMirrorsRepoError, Errors.RepoError):
+            _cleanup_tmp()
             if grab_can_fail:
                 return None
             raise
 
-
-        return result
+        # This should always work...
+        try:
+            os.rename(result, local)
+        except:
+            # But in case it doesn't...
+            _cleanup_tmp()
+            if grab_can_fail:
+                return None
+            raise Errors.RepoError, 'Error renaming file %s to %s' % (result,
+                                                                      local)
+        return local
 
     def _parseRepoXML(self, local, parse_can_fail=None):
         """ Parse the repomd.xml file. """
@@ -1294,27 +1322,22 @@ class YumRepository(Repository, config.RepoConf):
                 result = self._getFile(relative='repodata/repomd.xml.asc',
                                        copy_local=1,
                                        local = sigfile,
-                                       text='%s repo signature' % self.id,
+                                       text='%s/signature' % self.id,
                                        reget=None,
                                        checkfunc=None,
                                        cache=self.http_caching == 'all')
             except URLGrabError, e:
                 raise URLGrabError(-1, 'Error finding signature for repomd.xml for %s: %s' % (self, e))
 
-            if not os.path.exists(self.gpgdir):
-                if self.gpg_import_func:
-                    #FIXME probably should have an else off of this to
-                    # complain if there is no import function
-                    try:
-                        self.gpg_import_func(self, self.confirm_func)
-                    except Errors.YumBaseError, e:
-                        raise URLGrabError(-1, 'Gpg Keys not imported, cannot verify repomd.xml for repo %s' % (self))
-
-                    # FIXME if we get the okay here to import the key then
-                    # we should set an option so that future key imports for this
-                    # repo will be allowed w/o question
+            valid = misc.valid_detached_sig(result, filepath, self.gpgdir)
+            if not valid and self.gpg_import_func:
+                try:
+                    self.gpg_import_func(self, self.confirm_func)
+                except Errors.YumBaseError, e:
+                    raise URLGrabError(-1, 'Gpg Keys not imported, cannot verify repomd.xml for repo %s' % (self))
+                valid = misc.valid_detached_sig(result, filepath, self.gpgdir)
 
-            if not misc.valid_detached_sig(result, filepath, self.gpgdir):
+            if not valid:
                 raise URLGrabError(-1, 'repomd.xml signature could not be verified for %s' % (self))
 
         try:
diff --git a/yumcommands.py b/yumcommands.py
index d3ce5ee..3783292 100644
--- a/yumcommands.py
+++ b/yumcommands.py
@@ -29,6 +29,7 @@ import locale
 import fnmatch
 import time
 from yum.misc import to_unicode
+from yum.i18n import utf8_width, utf8_width_fill
 
 def checkRootUID(base):
     """
@@ -237,31 +238,54 @@ class InfoCommand(YumCommand):
 
     def doCommand(self, base, basecmd, extcmds):
         try:
-            ypl = base.returnPkgLists(extcmds)
+            highlight = base.term.MODE['bold']
+            ypl = base.returnPkgLists(extcmds, installed_available=highlight)
         except yum.Errors.YumBaseError, e:
             return 1, [str(e)]
         else:
             update_pkgs = {}
+            inst_pkgs   = {}
 
             columns = None
             if basecmd == 'list':
                 # Dynamically size the columns
                 columns = _list_cmd_calc_columns(base, ypl)
 
-            if ypl.installed:
+            if highlight and ypl.installed:
                 #  If we have installed and available lists, then do the
                 # highlighting for the installed packages so you can see what's
-                # available to install vs. available to update.
-                for pkg in ypl.available:
+                # available to update, an extra, or newer than what we have.
+                for pkg in (ypl.hidden_available +
+                            ypl.reinstall_available +
+                            ypl.old_available):
                     key = (pkg.name, pkg.arch)
                     if key not in update_pkgs or pkg.verGT(update_pkgs[key]):
                         update_pkgs[key] = pkg
 
+            if highlight and ypl.available:
+                #  If we have installed and available lists, then do the
+                # highlighting for the available packages so you can see what's
+                # available to install vs. update vs. old.
+                for pkg in ypl.hidden_installed:
+                    key = (pkg.name, pkg.arch)
+                    if key not in inst_pkgs or pkg.verGT(inst_pkgs[key]):
+                        inst_pkgs[key] = pkg
+
             # Output the packages:
+            clio = base.conf.color_list_installed_older
+            clin = base.conf.color_list_installed_newer
+            clie = base.conf.color_list_installed_extra
             rip = base.listPkgs(ypl.installed, _('Installed Packages'), basecmd,
-                                highlight_na=update_pkgs, columns=columns)
+                                highlight_na=update_pkgs, columns=columns,
+                                highlight_modes={'>' : clio, '<' : clin,
+                                                 'not in' : clie})
+            clau = base.conf.color_list_available_upgrade
+            clad = base.conf.color_list_available_downgrade
+            clai = base.conf.color_list_available_install
             rap = base.listPkgs(ypl.available, _('Available Packages'), basecmd,
-                                columns=columns)
+                                highlight_na=inst_pkgs, columns=columns,
+                                highlight_modes={'<' : clau, '>' : clad,
+                                                 'not in' : clai})
             rep = base.listPkgs(ypl.extras, _('Extra Packages'), basecmd,
                                 columns=columns)
             rup = base.listPkgs(ypl.updates, _('Updated Packages'), basecmd,
@@ -535,11 +559,25 @@ class CheckUpdateCommand(YumCommand):
         result = 0
         try:
             ypl = base.returnPkgLists(extcmds)
+            if base.verbose_logger.isEnabledFor(logginglevels.DEBUG_3):
+                typl = base.returnPkgLists(['obsoletes'])
+                ypl.obsoletes = typl.obsoletes
+                ypl.obsoletesTuples = typl.obsoletesTuples
+
             columns = _list_cmd_calc_columns(base, ypl)
             if len(ypl.updates) > 0:
                 base.listPkgs(ypl.updates, '', outputType='list',
                               columns=columns)
                 result = 100
+            if len(ypl.obsoletes) > 0: # This only happens in verbose mode
+                rop = [0, '']
+                print _('Obsoleting Packages')
+                # The tuple is (newPkg, oldPkg) ... so sort by new
+                for obtup in sorted(ypl.obsoletesTuples,
+                                    key=operator.itemgetter(0)):
+                    base.updatesObsoletesList(obtup, 'obsoletes',
+                                              columns=columns)
+                result = 100
         except yum.Errors.YumBaseError, e:
             return 1, [str(e)]
         else:
@@ -719,11 +757,9 @@ class RepoListCommand(YumCommand):
         # Setup so len(repo.sack) is correct
         base.repos.populateSack()
 
-        format_string = "%-20.20s %-40.40s %-8s%s"
         repos = base.repos.repos.values()
         repos.sort()
         enabled_repos = base.repos.listEnabled()
-        done = False
         verbose = base.verbose_logger.isEnabledFor(logginglevels.DEBUG_3)
         if arg == 'all':
             ehibeg = base.term.FG_COLOR['green'] + base.term.MODE['bold']
@@ -734,33 +770,32 @@ class RepoListCommand(YumCommand):
             dhibeg = ''
             hiend  = ''
         tot_num = 0
+        cols = []
         for repo in repos:
             if len(extcmds) and not _repo_match(repo, extcmds):
                 continue
             if repo in enabled_repos:
                 enabled = True
-                ui_enabled = ehibeg + _('enabled') + hiend
+                ui_enabled = ehibeg + _('enabled') + hiend + ": "
+                ui_endis_wid = utf8_width(_('enabled')) + 2
                 num        = len(repo.sack)
                 tot_num   += num
                 ui_num     = to_unicode(locale.format("%d", num, True))
-                ui_fmt_num = ": %7s"
                 if verbose:
                     ui_size = _repo_size(repo)
             else:
                 enabled = False
                 ui_enabled = dhibeg + _('disabled') + hiend
+                ui_endis_wid = utf8_width(_('disabled'))
                 ui_num     = ""
-                ui_fmt_num = "%s"
                 
             if (arg == 'all' or
                 (arg == 'enabled' and enabled) or
                 (arg == 'disabled' and not enabled)):
-                if not done and not verbose:
-                    base.verbose_logger.log(logginglevels.INFO_2,
-                                            format_string, _('repo id'),
-                                            _('repo name'), _('status'), "")
-                done = True
-                if verbose:
+                if not verbose:
+                    cols.append((str(repo), repo.name,
+                                 (ui_enabled, ui_endis_wid), ui_num))
+                else:
                     md = repo.repoXML
                     out = [base.fmtKeyValFill(_("Repo-id     : "), repo),
                            base.fmtKeyValFill(_("Repo-name   : "), repo.name),
@@ -812,10 +847,47 @@ class RepoListCommand(YumCommand):
                     base.verbose_logger.log(logginglevels.DEBUG_3,
                                             "%s\n",
                                             "\n".join(out))
-                else:
-                    base.verbose_logger.log(logginglevels.INFO_2, format_string,
-                                            repo, repo.name, ui_enabled,
-                                            ui_fmt_num % ui_num)
+
+        if not verbose and cols:
+            #  Work out the first (id) and last (enabled/disalbed/count),
+            # then chop the middle (name)...
+            id_len = utf8_width(_('repo id'))
+            nm_len = 0
+            ct_len = 0
+            ui_len = 0
+
+            for (rid, rname, (ui_enabled, ui_endis_wid), ui_num) in cols:
+                if id_len < utf8_width(rid):
+                    id_len = utf8_width(rid)
+                if nm_len < utf8_width(rname):
+                    nm_len = utf8_width(rname)
+                if ct_len < ui_endis_wid:
+                    ct_len = ui_endis_wid
+                if ui_len < len(ui_num):
+                    ui_len = len(ui_num)
+            if utf8_width(_('status')) > ct_len + ui_len:
+                left = base.term.columns - (id_len + utf8_width(_('status')) +2)
+            else:
+                left = base.term.columns - (id_len + ct_len + ui_len + 2)
+
+            if left < nm_len: # Name gets chopped
+                nm_len = left
+            else: # Share the extra...
+                left -= nm_len
+                id_len += left / 2
+                nm_len += left - (left / 2)
+
+            txt_rid  = utf8_width_fill(_('repo id'), id_len)
+            txt_rnam = utf8_width_fill(_('repo name'), nm_len, nm_len)
+            base.verbose_logger.log(logginglevels.INFO_2,"%s %s %s",
+                                    txt_rid, txt_rnam, _('status'))
+            for (rid, rname, (ui_enabled, ui_endis_wid), ui_num) in cols:
+                if ui_num:
+                    ui_num = utf8_width_fill(ui_num, ui_len, left=False)
+                base.verbose_logger.log(logginglevels.INFO_2, "%s %s %s%s",
+                                        utf8_width_fill(rid, id_len),
+                                        utf8_width_fill(rname, nm_len, nm_len),
+                                        ui_enabled, ui_num)
 
         return 0, ['repolist: ' +to_unicode(locale.format("%d", tot_num, True))]
 
